var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  pluginTypeDoc: () => pluginTypeDoc
});
module.exports = __toCommonJS(src_exports);
var import_path2 = __toESM(require("path"));
var import_typedoc = require("typedoc");
var import_typedoc_plugin_markdown = require("typedoc-plugin-markdown");

// src/constants.ts
var API_DIR = "api";
var ROUTE_PREFIX = `/${API_DIR}`;

// src/sidebar.ts
var import_path = __toESM(require("path"));
var import_fs_extra = __toESM(require("@modern-js/utils/fs-extra"));

// src/utils.ts
function transformModuleName(name) {
  return name.replace(/\//g, "_").replace(/-/g, "_");
}

// src/sidebar.ts
function patchLinks(outputDir) {
  return __async(this, null, function* () {
    const normlizeLinksInFile = (filePath) => __async(this, null, function* () {
      const content = yield import_fs_extra.default.readFile(filePath, "utf-8");
      const newContent = content.replace(
        /\[([^\]]+)\]\(([^)]+)\)/g,
        (_match, p1, p2) => {
          return `[${p1}](./${p2})`;
        }
      );
      yield import_fs_extra.default.writeFile(filePath, newContent);
    });
    const traverse = (dir) => __async(this, null, function* () {
      const files = yield import_fs_extra.default.readdir(dir);
      for (const file of files) {
        const filePath = import_path.default.join(dir, file);
        const stat = yield import_fs_extra.default.stat(filePath);
        if (stat.isDirectory()) {
          yield traverse(filePath);
        } else if (stat.isFile() && /\.mdx?/.test(file)) {
          yield normlizeLinksInFile(filePath);
        }
      }
    });
    yield traverse(outputDir);
  });
}
function resolveSidebarForSingleEntry(jsonFile) {
  return __async(this, null, function* () {
    const result = [];
    const data = JSON.parse(yield import_fs_extra.default.readFile(jsonFile, "utf-8"));
    if (!data.children || data.children.length <= 0) {
      return [];
    }
    const symbolMap = /* @__PURE__ */ new Map();
    data.groups.forEach((group) => {
      const groupItem = {
        text: group.title,
        items: []
      };
      group.children.forEach((id) => {
        const dataItem = data.children.find((item) => item.id === id);
        if (dataItem) {
          let fileName = dataItem.name;
          if (symbolMap.has(dataItem.name)) {
            const count = symbolMap.get(dataItem.name) + 1;
            symbolMap.set(dataItem.name, count);
            fileName = `${dataItem.name}-${count}`;
          } else {
            symbolMap.set(dataItem.name.toLocaleLowerCase(), 0);
          }
          groupItem.items.push({
            text: dataItem.name,
            link: `${ROUTE_PREFIX}/${group.title.toLocaleLowerCase()}/${fileName}`
          });
        }
      });
      result.push(groupItem);
    });
    yield patchLinks(import_path.default.dirname(jsonFile));
    return result;
  });
}
function resolveSidebarForMultiEntry(jsonFile) {
  return __async(this, null, function* () {
    const result = [];
    const data = JSON.parse(yield import_fs_extra.default.readFile(jsonFile, "utf-8"));
    if (!data.children || data.children.length <= 0) {
      return result;
    }
    function getModulePath(name) {
      return import_path.default.join(`${ROUTE_PREFIX}/modules`, `${transformModuleName(name)}`).replace(/\\/g, "/");
    }
    function getClassPath(moduleName, className) {
      return import_path.default.join(
        `${ROUTE_PREFIX}/classes`,
        `${transformModuleName(moduleName)}.${className}`
      ).replace(/\\/g, "/");
    }
    function getInterfacePath(moduleName, interfaceName) {
      return import_path.default.join(
        `${ROUTE_PREFIX}/interfaces`,
        `${transformModuleName(moduleName)}.${interfaceName}`
      ).replace(/\\/g, "/");
    }
    function getFunctionPath(moduleName, functionName) {
      return import_path.default.join(
        `${ROUTE_PREFIX}/functions`,
        `${transformModuleName(moduleName)}.${functionName}`
      ).replace(/\\/g, "/");
    }
    data.children.forEach((module2) => {
      const moduleNames = module2.name.split("/");
      const name = moduleNames[moduleNames.length - 1];
      const moduleConfig = {
        text: `Module:${name}`,
        items: [{ text: "Overview", link: getModulePath(module2.name) }]
      };
      if (!module2.children || module2.children.length <= 0) {
        return;
      }
      module2.children.forEach((sub) => {
        var _a;
        const kindString = (_a = module2.groups.find((item) => item.children.includes(sub.id))) == null ? void 0 : _a.title.slice(0, -1);
        if (!kindString) {
          return;
        }
        switch (kindString) {
          case "Class":
            moduleConfig.items.push({
              text: `Class:${sub.name}`,
              link: getClassPath(module2.name, sub.name)
            });
            break;
          case "Interface":
            moduleConfig.items.push({
              text: `Interface:${sub.name}`,
              link: getInterfacePath(module2.name, sub.name)
            });
            break;
          case "Function":
            moduleConfig.items.push({
              text: `Function:${sub.name}`,
              link: getFunctionPath(module2.name, sub.name)
            });
            break;
          default:
            break;
        }
      });
      result.push(moduleConfig);
    });
    yield patchLinks(import_path.default.dirname(jsonFile));
    return result;
  });
}

// src/index.ts
function pluginTypeDoc(options) {
  let docRoot;
  const { entryPoints = [], outDir = API_DIR } = options;
  return {
    name: "doc-plugin-typedoc",
    addPages() {
      return __async(this, null, function* () {
        return [
          {
            routePath: `${outDir.replace(/\/$/, "")}/`,
            filepath: import_path2.default.join(docRoot, outDir, "README.md")
          }
        ];
      });
    },
    config(config) {
      return __async(this, null, function* () {
        const app = new import_typedoc.Application();
        docRoot = config.root;
        app.options.addReader(new import_typedoc.TSConfigReader());
        (0, import_typedoc_plugin_markdown.load)(app);
        app.bootstrap({
          name: config.title,
          entryPoints,
          theme: "markdown",
          disableSources: true,
          readme: "none",
          githubPages: false,
          requiredToBeDocumented: ["Class", "Function", "Interface"],
          plugin: ["typedoc-plugin-markdown"],
          // @ts-expect-error MarkdownTheme has no export
          hideBreadcrumbs: true,
          hideMembersSymbol: true,
          allReflectionsHaveOwnDocument: true
        });
        const project = app.convert();
        if (project) {
          const absoluteOutputdir = import_path2.default.join(docRoot, outDir);
          yield app.generateDocs(project, absoluteOutputdir);
          const jsonDir = import_path2.default.join(absoluteOutputdir, "documentation.json");
          yield app.generateJson(project, jsonDir);
          config.themeConfig = config.themeConfig || {};
          config.themeConfig.nav = config.themeConfig.nav || [];
          const apiIndexLink = `/${outDir.replace(/(^\/)|(\/$)/, "")}/`;
          config.themeConfig.nav.push({
            text: "API",
            link: apiIndexLink
          });
          config.themeConfig.sidebar = config.themeConfig.sidebar || {};
          config.themeConfig.sidebar[apiIndexLink] = entryPoints.length > 1 ? yield resolveSidebarForMultiEntry(jsonDir) : yield resolveSidebarForSingleEntry(jsonDir);
          config.themeConfig.sidebar[apiIndexLink].unshift({
            text: "Overview",
            link: `${apiIndexLink}README`
          });
        }
        config.route = config.route || {};
        config.route.exclude = config.route.exclude || [];
        return config;
      });
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  pluginTypeDoc
});

//# sourceMappingURL=index.js.map